<?php 
try{

	// 디버깅 시
	// error_reporting( E_ALL );
	// ini_set( "display_errors", 1 );
	include_once dirname(__FILE__)."/../config.php";
	include_once dirname(__FILE__)."/../lib/module.php";
	include_once dirname(__FILE__)."/../lib/item.php";

	extract($_REQUEST);

	if( session_status() == PHP_SESSION_NONE){
		session_start();
	}

	// ready.php 단계에서 저장한 요청/응답데이터
	$requestData = $_SESSION['kakao/ready/requestData'];
	$responseData = $_SESSION['kakao/ready/responseData'];
	if( empty($responseData['tid']) ){
		throw new Exception("거래번호가 누락되었습니다.");
	}

	if( empty($pg_token) ){
		throw new Exception("거래토큰이 누락되었습니다.");
	}

	// 요청데이터
	$approvalRequestData = array(
		'cid'=>$kakaoConfig['cid'],
		'tid'=>$responseData['tid'],
		'partner_order_id'=>$requestData['partner_order_id'],
		'partner_user_id'=>$requestData['partner_user_id'],
		'pg_token'=>$pg_token,
		'total_amount'=>$requestData['total_amount'],  // 필수는 아니나 보안상 ready.php 에서 요청했던 데이터값을 보내준다.
	);

	// 요청 헤더 & URI
	$header = array("Authorization: KakaoAK ".$kakaoConfig['ak']);
	$requestURI = $kakaoConfig['uri']['approve'].'?'.http_build_query($approvalRequestData);
		
	// 카카오페이 요청
	$approvalResponse = curl_kakao($requestURI,$header);
	$approvalResponseData = json_decode($approvalResponse,true); // jsonString 데이터를 배열타입으로 받는다.


/*	
	echo '<pre>';
	print_r($responseData);	

	Array
	(
	    [aid] => A3b97ebe003e7c982453
	    [tid] => T3b97eb44a466e292bf7
	    [cid] => TC0ONETIME
	    [partner_order_id] => 16731009805209134632
	    [partner_user_id] => 46b58dcd20e35e4afec0a579bad40f52
	    [payment_method_type] => MONEY
	    [item_name] => 왕의 반지 파격 세일!
	    [item_code] => 20230107
	    [quantity] => 1
	    [amount] => Array
	        (
	            [total] => 3500
	            [tax_free] => 0
	            [vat] => 318
	            [point] => 3500
	            [discount] => 0
	            [green_deposit] => 0
	        )

	    [created_at] => 2023-01-07T23:16:21
	    [approved_at] => 2023-01-07T23:16:35
	)
*/

	// 이후에는 최종 결제처리 진행 
	$msg = '결제가 완료되었습니다.';
	include dirname(__FILE__)."/response.php";
}
catch(Exception $e){

	$msg = $e->getMessage();
	include dirname(__FILE__)."/response.php";
	
}
