<?php 
try{

	// 디버깅 시
	// error_reporting( E_ALL );
	// ini_set( "display_errors", 1 );
	include_once dirname(__FILE__)."/../config.php";
	include_once dirname(__FILE__)."/../lib/module.php";
	include_once dirname(__FILE__)."/../lib/item.php";

	$parse_url = parse_url($_SERVER['HTTP_REFERER']);
	if( $parse_url['host'] != $_SERVER['HTTP_HOST']){
		throw new Exception("잘못된 접근입니다.");
	}

	extract($_POST);

	// 아이템체크: 코드
	if( empty($item_code) || empty($item[$item_code]['code'])){ throw new Exception("상품정보가 없습니다."); }

	// 아이템체크: 수량
	if( $quantity < 1){ throw new Exception("수량을 선택해 주시기 바랍니다."); }

	// 총 구매가격 
	$total_amount = ($item[$item_code]['price']['new']*$quantity)+$item[$item_code]['delivery']['price'];

	// 아이템을 구성한다. (https://developers.kakao.com/docs/latest/ko/kakaopay/single-payment)
	$requestData = array(
		'cid'=>$kakaoConfig['cid'],
		'partner_order_id'=>create_order_id(),
		'partner_user_id'=>md5(serialize($_SERVER)),
		'item_name'=>$item[$item_code]['name'],
		'item_code'=>$item[$item_code]['code'],
		'quantity'=>$quantity,
		'total_amount'=>$total_amount,
		'tax_free_amount'=>0,
		'approval_url'=>$kakaoConfig['domain'].'/kakao/pay/api/approval.php',
		'cancel_url'=>$kakaoConfig['domain'].'/kakao/pay/api/response.php',
		'fail_url'=>$kakaoConfig['domain'].'/kakao/pay/api/response.php',
	);

	// 요청 헤더 & URI
	$header = array("Authorization: KakaoAK ".$kakaoConfig['ak']);
	$requestURI = $kakaoConfig['uri']['ready'].'?'.http_build_query($requestData);
		
	// 카카오페이 요청
	$response = curl_kakao($requestURI,$header);
	$responseData = json_decode($response,true); // jsonString 데이터를 배열타입으로 받는다.

	// 결과값을 파싱하여 처리
	if( empty($responseData)){
		throw new Exception('결제요청실패');	
	}	
	if( isset($responseData['msg']) ){
		throw new Exception('('.(isset($responseData['code']) ? $responseData['code'] : '-1').')'.$responseData['msg']);
	}

	// 세션에 정보를 담는다. !! 실환경에서는 단발성 세션이 아닌 DB에 주문번호와 함께 처리하셔야합니다. 
	if( session_status() == PHP_SESSION_NONE){
		session_start();
	}
	$_SESSION['kakao/ready/requestData'] = $requestData; // 요청데이터
	$_SESSION['kakao/ready/responseData'] = $responseData; // 응답데이터


	die(json_encode(array('rst'=>'success','mobile'=>(check_mobile() === true ? 'Y':'N'), 'responseData'=>$responseData )));
}
catch(Exception $e){
	die(json_encode(array('rst'=>'fail','msg'=>$e->getMessage())));
}
