<?php 
/*
	****************************************************************************
	** 본 문서는 법적으로 저작권은 없으나 포스팅 시 저작권자를 표기해주었으면 합니다. 
	****************************************************************************
	
	** 포스팅URL: https://blog.redinfo.co.kr/post/view?pid=158
	** 작성자: REDINFO(lcy@redinfo.co.kr) 
*/
?>
<!DOCTYPE html>
<html>
    <head>
    <meta charset="utf-8"> 
        <title>카카오페이 구매하기 예제</title>

        <!-- 카카오페이 SDK :  https://developers.kakao.com/docs/latest/ko/sdk-download/js --> 
        <script src="https://t1.kakaocdn.net/kakao_js_sdk/2.1.0/kakao.min.js" integrity="sha384-dpu02ieKC6NUeKFoGMOKz6102CLEWi9+5RQjWSV0ikYSFFd8M3Wp2reIcquJOemx" crossorigin="anonymous"></script>

        <!-- juqery 3.5.1 -->
        <script src="//code.jquery.com/jquery-3.5.1.min.js" integrity="sha256-9/aliU8dGd2tb6OSsuzixeV4y/faTqgFtohetphbbj0=" crossorigin="anonymous"></script> 

        <link href="style.css?v=<?php echo time();?>" rel="stylesheet">
    </head>
    <body>
    	<?php 
    		// 아이템정보를 가져온다.  !! 실운영시에는 DB에서 가져와야함
    		include_once dirname(__FILE__)."/lib/item.php";

    		// 랜덤하게 아이템 한개를 선택한다. !! 실운영시에는 DB에서 가져와야함
    		$loadItem = $item[array_rand($item)];
    	?>
		<div class="container">
			<form id="form-buy">
				<input type="hidden" name="delivery_price" value="<?php echo $loadItem['delivery']['price'] ?>">
				<input type="hidden" name="price" value="<?php echo $loadItem['price']['new'] ?>">
				<input type="hidden" name="item_code" value="<?php echo $loadItem['code'] ?>">

				<div class="item-image"><?php echo $loadItem['image'] ?></div>
				<div class="item-name"><?php echo $loadItem['name'] ?></div>
				<div class="item-desc"><?php echo $loadItem['desc'] ?></div>
				<div class="item-info">
					<div class="delivery">
						<div class="info"><?php echo $loadItem['delivery']['info'] ?></div>
						<div class="info">배송비 <?php echo number_format($loadItem['delivery']['price']) ?></div>
					</div>

					<div class="price">
						<span class="org"><?php echo number_format($loadItem['price']['org']) ?></span>
						<span class="new"><?php echo number_format($loadItem['price']['new']) ?></span>
					</div>
				</div>

				<div class="item-quantity">
					<a href="#none" class="trigger-quantity" data-type="down" onclick="return false;">－</a>
					<input type="text" name="quantity" id="quantity" value="1" readonly="">
					<a href="#none" class="trigger-quantity" data-type="up" onclick="return false;">＋</a>
				</div>

				<div class="item-total-price">
					<strong>결제금액</strong>
					<span class="price" id="price"><?php echo number_format($loadItem['price']['new']+$loadItem['delivery']['price']) ?></span>
				</div>

				<div class="buy-btn">
					<a href="#none" id="kakaopay-buy"onclick="return false;">
						<span class="txt">간편하게 카카오 페이로 구매!</span>
						<img src="res/payment_icon_yellow_medium.png">
					</a>
				</div>
			</form>
		</div>     

		<script>
			// 수량 
			$(document).on('click','.trigger-quantity',function(e){
				var $form = $('#form-buy');
				var thisData = $(this).data();
				var quantity = $form.find('input[name="quantity"]').val()*1;
				var price = $form.find('input[name="price"]').val()*1;
				var delivery_price = $form.find('input[name="delivery_price"]').val()*1;
				if( thisData.type == 'up'){
					quantity++;
				}
				else if(thisData.type == 'down'){
					if( quantity <= 1){
						return false;
					}
					quantity--;
				}
				else{ alert("에러가 발생하였습니다."); return false; }

				$form.find('input[name="quantity"]').val(quantity);
				var total_price = (price*quantity)+delivery_price;
				$('#price').text( total_price.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',') );

			});


			//구매
			$(document).on('click','#kakaopay-buy',function(e){
				var $form = $('#form-buy');
				var formSerialize = $form.serialize();
				var quantity = $form.find('input[name="quantity"]').val()*1;
				if( quantity < 1){  alert('수량을 선택해 주세요.'); return false; }
				$.ajax({url:'api/ready.php',dataType:'json', type:'post' , data:formSerialize})
				.done(function(e){
					if(e.rst != 'success'){ alert(e.msg); return false; }

					// 결제창 호출준비
					if(e.mobile == 'Y'){
						location.href = e.responseData.next_redirect_mobile_url;
					}
					else{
						window.open(e.responseData.next_redirect_pc_url, "카카오결제", "width=300,height:500,top=0;");
					}
				})
				.fail(function(i){
					// 통신 요청실패 
					console.log(i.responseText);
					alert('통신에러가 발생하였습니다.');
				});
			});
		</script>
    </body>
</html>